//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  Gray
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_level1  0

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame  = PERIOD_CURRENT;
extern int                TTFbars             = 14;
extern ENUM_APPLIED_PRICE TTFHighPrice = PRICE_HIGH;
extern ENUM_APPLIED_PRICE TTFLowPrice  = PRICE_LOW;
extern int                topLine             = 100;
extern int                bottomLine          = -100;
extern double             T3Period            = 3;
extern double             T3Hot               = 0.7;
extern bool               T3Original          = false;
extern bool               showTopBottomLevels = true;
extern bool               showSignals         = true;

//
//
//
//
//

double ttf[];
double lev[];
double sigu[];
double sigd[];
double trend[];
double trends[];
double priceh[];
double pricel[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,lev);
      SetIndexBuffer(1,ttf);
      SetIndexBuffer(2,sigu); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
      SetIndexBuffer(3,sigd); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,trends);
      SetIndexBuffer(6,priceh);
      SetIndexBuffer(7,pricel);
   
      //
      //
      //
      //
      //
   
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame == -99);
        TimeFrame         = MathMax(TimeFrame,_Period);   

     //
     //
     //
     //
     //
   
    IndicatorShortName(timeFrameToString(TimeFrame)+"  TTF new");           
    return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-2);
         if (returnBars) { lev[0] = limit+1; return(0); }
            
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      int skip=0; if (TTFHighPrice==TTFLowPrice) skip=1;
      for(int i=limit; i >= 0; i--)
      {
         priceh[i] = iMA(NULL,0,1,0,MODE_SMA,TTFHighPrice,i);
         pricel[i] = iMA(NULL,0,1,0,MODE_SMA,TTFLowPrice ,i);
         double HighestHighRecent = priceh[ArrayMaximum(priceh,TTFbars,(int)MathMin(Bars-1,i))        ];
         double HighestHighOlder  = priceh[ArrayMaximum(priceh,TTFbars,(int)MathMin(Bars-1,i+TTFbars))];
         double LowestLowRecent   = pricel[ArrayMinimum(pricel,TTFbars,(int)MathMin(Bars-1,i+skip))        ];
         double LowestLowOlder    = pricel[ArrayMinimum(pricel,TTFbars,(int)MathMin(Bars-1,i+skip+TTFbars))];
      
            double BuyPower  = HighestHighRecent - LowestLowOlder;
            double SellPower = HighestHighOlder  - LowestLowRecent;
               if (BuyPower+SellPower!=0)
                  ttf[i] = iT3((BuyPower-SellPower)/(0.5*(BuyPower+SellPower))*100.0,T3Period,T3Hot,T3Original,i);
      
         //
         //
         //
         //
         //
         
         if (showTopBottomLevels)
         {
            trend[i] = trend[i+1];
               if (ttf[i] > 0) trend[i] =  1;
               if (ttf[i] < 0) trend[i] = -1;
               if (trend[i]== 1) lev[i] = topLine;
               if (trend[i]==-1) lev[i] = bottomLine;
         }
      
         if (showSignals)
         {
            sigu[i] = EMPTY_VALUE;
            sigd[i] = EMPTY_VALUE;
            trends[i] = 0;
               if (ttf[i] > topLine)    trends[i] =  1;
               if (ttf[i] < bottomLine) trends[i] = -1;
               if (trends[i]== 1) sigu[i] = topLine;
               if (trends[i]==-1) sigd[i] = bottomLine;
         }
      }
      return(0);
   }
   
   //
   //
   //
   //
   //       
    
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period())); 
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         lev[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TTFbars,TTFHighPrice,TTFLowPrice,topLine,bottomLine,T3Period,T3Hot,T3Original,showTopBottomLevels,showSignals,0,y);
         ttf[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TTFbars,TTFHighPrice,TTFLowPrice,topLine,bottomLine,T3Period,T3Hot,T3Original,showTopBottomLevels,showSignals,1,y);
         trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TTFbars,TTFHighPrice,TTFLowPrice,topLine,bottomLine,T3Period,T3Hot,T3Original,showTopBottomLevels,showSignals,4,y);
         trends[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TTFbars,TTFHighPrice,TTFLowPrice,topLine,bottomLine,T3Period,T3Hot,T3Original,showTopBottomLevels,showSignals,5,y);
         sigu[i]   = EMPTY_VALUE;
         sigd[i]   = EMPTY_VALUE;
         
         //
         //
         //
         //
         //
         
         if (showTopBottomLevels)
         {
            trend[i] = trend[i+1];
               if (ttf[i] > 0) trend[i] =  1;
               if (ttf[i] < 0) trend[i] = -1;
               if (trend[i]== 1) lev[i] = topLine;
               if (trend[i]==-1) lev[i] = bottomLine;
         }
      
         if (showSignals)
         {
            trends[i] = 0;
               if (ttf[i] > topLine)    trends[i] =  1;
               if (ttf[i] < bottomLine) trends[i] = -1;
               if (trends[i]== 1) sigu[i] = topLine;
               if (trends[i]==-1) sigd[i] = bottomLine;
         }
   }
   return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}